// Copyright (c) Microsoft Corporation. 
// Licensed under the MIT license.

#pragma once
#include "CoreMinimal.h"

class FScopedFPExceptionMaskState
{
public:
	FScopedFPExceptionMaskState();

	~FScopedFPExceptionMaskState();

private:
	uint32 CurrentControlWord;
	bool RequiresRestore;
};

#define RESTORE_FP_CTRL_WORD_MCW_EM( fn )  \
	do                                     \
	{                                      \
		FScopedFPExceptionMaskState state; \
		fn;                                \
	} while( false )
